window.Gleam.initSearch([{"doc":"gleatter_lustre","title":"gleatter_lustre","content":"# gleatter_lustre\n\nInterface for lustre to use gleatter&#39;s typed routes\n\n[![Package Version](https://img.shields.io/hexpm/v/gleatter_lustre)](https://hex.pm/packages/gleatter_lustre)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/gleatter_lustre/)\n\n```sh\ngleam add gleatter_lustre\n```\n```gleam\nimport gleatter/lustre as glustre\nimport gleam/http\nimport lustre\nimport lustre/effect\n\npub fn main() {\n  let app = lustre.application(init, update, view)\n  let assert Ok(_) = lustre.start(app, &quot;#app&quot;, Nil)\n\n  Nil\n}\n\nfn update(model: Model, msg: Msg) -&gt; #(Model, Effect(Msg)) {\n  case msg {\n    TodoAdded(title) -&gt; #(model, glustre.create_factory()\n      |&gt; glustre.with_scheme(http.Http)\n      |&gt; glustre.with_host(&quot;localhost&quot;)\n      |&gt; glustre.with_port(2345)\n      |&gt; glustre.for_route(todo_service() |&gt; create_route)\n      |&gt; glustre.with_body(CreateTodo(title))\n      |&gt; glustre.send(ServerCreatedTodo, fn(_) { effect.none() })\n    )\n    ServerCreatedTodo(Ok(new_todo)) -&gt; #([new_todo, ..model], effect.none())\n    _ -&gt; #(model, effect.none())\n  }\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/gleatter_lustre&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\n```\n","url":"index.html"},{"doc":"gleatter/lustre","title":"RequestFactory","content":"pub opaque type RequestFactory\n\n\nSynonyms:\ngleatter/lustre.RequestFactory\ngleatter/lustre RequestFactory","url":"gleatter/lustre.html#RequestFactory"},{"doc":"gleatter/lustre","title":"RouteOptions","content":"pub type RouteOptions(p, q, b) {\n  RouteOptions(path: p, query: q, body: b)\n}\n\nRouteOptions(path: p, query: q, body: b)\n\n\nSynonyms:\ngleatter/lustre.RouteOptions\ngleatter/lustre RouteOptions","url":"gleatter/lustre.html#RouteOptions"},{"doc":"gleatter/lustre","title":"RouteRequest","content":"pub opaque type RouteRequest(p, q, b, c)\n A RouteRequest contains the data required to send a request to a backend  \n This data contains a route, all the data from the factory that created the request\n as well as path, query and body data that will have to be provided\n\nSynonyms:\ngleatter/lustre.RouteRequest\ngleatter/lustre RouteRequest","url":"gleatter/lustre.html#RouteRequest"},{"doc":"gleatter/lustre","title":"create_factory","content":"pub fn create_factory() -&gt; RequestFactory\n Create a new default factory  \n By default, it points to &quot;http://localhost:80&quot;\nSynonyms:\ngleatter/lustre.create_factory\ngleatter/lustre create_factory","url":"gleatter/lustre.html#create_factory"},{"doc":"gleatter/lustre","title":"for_route","content":"pub fn for_route(\n  factory: RequestFactory,\n  route: Route(a, b, c, d),\n) -&gt; RouteRequest(a, b, c, d)\n Create a RouteRequest given a RequestFactory and a Route\nSynonyms:\ngleatter/lustre.for_route\ngleatter/lustre for_route","url":"gleatter/lustre.html#for_route"},{"doc":"gleatter/lustre","title":"send","content":"pub fn send(\n  rreq: RouteRequest(a, b, c, d),\n  as_msg: fn(Result(d, HttpError)) -&gt; e,\n  on_error: fn(String) -&gt; Effect(e),\n) -&gt; Effect(e)\n Send a RouteRequest and handle the result  \n Uses lustre_http under the hood to send the result, catch the response and transform the data\nSynonyms:\ngleatter/lustre.send\ngleatter/lustre send","url":"gleatter/lustre.html#send"},{"doc":"gleatter/lustre","title":"with_body","content":"pub fn with_body(\n  request: RouteRequest(a, b, c, d),\n  body: c,\n) -&gt; RouteRequest(a, b, c, d)\n Set the body data for this request\nSynonyms:\ngleatter/lustre.with_body\ngleatter/lustre with_body","url":"gleatter/lustre.html#with_body"},{"doc":"gleatter/lustre","title":"with_host","content":"pub fn with_host(\n  factory: RequestFactory,\n  host: String,\n) -&gt; RequestFactory\n Changes the host of a RequestFactory\nSynonyms:\ngleatter/lustre.with_host\ngleatter/lustre with_host","url":"gleatter/lustre.html#with_host"},{"doc":"gleatter/lustre","title":"with_options","content":"pub fn with_options(\n  request: RouteRequest(a, b, c, d),\n  options: RouteOptions(a, b, c),\n) -&gt; RouteRequest(a, b, c, d)\n Set the path, query and body data all at the same time\nSynonyms:\ngleatter/lustre.with_options\ngleatter/lustre with_options","url":"gleatter/lustre.html#with_options"},{"doc":"gleatter/lustre","title":"with_path","content":"pub fn with_path(\n  request: RouteRequest(a, b, c, d),\n  path: a,\n) -&gt; RouteRequest(a, b, c, d)\n Set the path data for this request  \nSynonyms:\ngleatter/lustre.with_path\ngleatter/lustre with_path","url":"gleatter/lustre.html#with_path"},{"doc":"gleatter/lustre","title":"with_port","content":"pub fn with_port(\n  factory: RequestFactory,\n  port: Int,\n) -&gt; RequestFactory\n Changes the port of a RequestFactory\nSynonyms:\ngleatter/lustre.with_port\ngleatter/lustre with_port","url":"gleatter/lustre.html#with_port"},{"doc":"gleatter/lustre","title":"with_query","content":"pub fn with_query(\n  request: RouteRequest(a, b, c, d),\n  query: b,\n) -&gt; RouteRequest(a, b, c, d)\n Set the query data for this request\nSynonyms:\ngleatter/lustre.with_query\ngleatter/lustre with_query","url":"gleatter/lustre.html#with_query"},{"doc":"gleatter/lustre","title":"with_scheme","content":"pub fn with_scheme(\n  factory: RequestFactory,\n  scheme: Scheme,\n) -&gt; RequestFactory\n Changes the scheme of a RequestFactory  \n Also sets the port to the default for the selected scheme (80 for http and 443 for https)\nSynonyms:\ngleatter/lustre.with_scheme\ngleatter/lustre with_scheme","url":"gleatter/lustre.html#with_scheme"},{"doc":"gleatter/lustre","title":"gleatter/lustre","content":" This module helps to make the bridge between gleatter Routes and Lustre","url":"gleatter/lustre.html"}]);